<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_BookingListRSReservation ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_BookingListRSReservation extends AbstractStructArrayBase
{
    /**
     * The Reservation
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Reservation[]
     */
    public $Reservation;
    /**
     * Constructor method for ArrayOfJP_BookingListRSReservation
     * @uses ArrayOfJP_BookingListRSReservation::setReservation()
     * @param \StructType\Reservation[] $reservation
     */
    public function __construct(array $reservation = array())
    {
        $this
            ->setReservation($reservation);
    }
    /**
     * Get Reservation value
     * @return \StructType\Reservation[]|null
     */
    public function getReservation()
    {
        return $this->Reservation;
    }
    /**
     * Set Reservation value
     * @throws \InvalidArgumentException
     * @param \StructType\Reservation[] $reservation
     * @return \ArrayType\ArrayOfJP_BookingListRSReservation
     */
    public function setReservation(array $reservation = array())
    {
        foreach ($reservation as $arrayOfJP_BookingListRSReservationReservationItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_BookingListRSReservationReservationItem instanceof \StructType\Reservation) {
                throw new \InvalidArgumentException(sprintf('The Reservation property can only contain items of \StructType\Reservation, "%s" given', is_object($arrayOfJP_BookingListRSReservationReservationItem) ? get_class($arrayOfJP_BookingListRSReservationReservationItem) : gettype($arrayOfJP_BookingListRSReservationReservationItem)), __LINE__);
            }
        }
        $this->Reservation = $reservation;
        return $this;
    }
    /**
     * Add item to Reservation value
     * @throws \InvalidArgumentException
     * @param \StructType\Reservation $item
     * @return \ArrayType\ArrayOfJP_BookingListRSReservation
     */
    public function addToReservation(\StructType\Reservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Reservation) {
            throw new \InvalidArgumentException(sprintf('The Reservation property can only contain items of \StructType\Reservation, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Reservation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Reservation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Reservation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Reservation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Reservation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Reservation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Reservation
     */
    public function getAttributeName()
    {
        return 'Reservation';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_BookingListRSReservation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
